// Animation control with time
final int MAX= 5;
final int timeSpan = 1000;  // milliseconds for each element

color [ ] cols;
int index;

int currentTime;

void setup( )
{
  size( 300, 300 );
  textAlign( CENTER, CENTER );
  textSize( 48 );
  cols = new color[ MAX ];
  initArray( );

  index = 0;
  currentTime = millis( );
}
void draw ( )
{
   background( 0 );
   determineArrayIndex( );
   showData( );
   
}

void determineArrayIndex( )
{
       // first way to determine index
//      if (millis( ) % timeSpan == 0 )
     int timePassed = millis() - currentTime;
     if ( timePassed >= timeSpan )
     {
         index++;
         currentTime = millis( );
     }
       // we have to protect the array bounds
     if ( index >= cols.length)
     {
        index = 0; 
     }
  
       // second way to determine index
//     int n = millis( )/timeSpan;
//     index = n%cols.length;
     
       // third way to determine index
//     index = (millis( )/timeSpan)%cols.length;

}

void showData( )
{
   fill(cols[index] );
   rect( width*.2, height*.2, width*.6, height*.6 );
   fill( 0 );
   text( index, width/2, height/2 );
   text( "index:", width/2, height*.3);
}

void initArray( )
{
   for( int i = 0; i < cols.length; i++)
   {
      float r = random( 256 );
      float g = random( 256 );
      float b = random( 256 );
      cols[i] = color( r, b, g );
   }
}
