// Animation control with button click
final int MAX= 5;

final int LEFTX = 50;
final int RIGHTX = 250;
final int Y = 20;
final int BUTTON_HEIGHT = 20;
final int BUTTON_WIDTH = 40 ;

color [ ] cols;
int index;


void setup( )
{
  size( 300, 300 );
  textAlign( CENTER, CENTER );

  
  cols = new color[ MAX ];
  initArray( );

  index = 0;
}
void draw ( )
{
   background( 0 );
   drawButtons( );
   showData( );
   
}

void drawButtons( )
{
    rectMode( CENTER );
    fill( 255 );
    rect( LEFTX, Y, BUTTON_WIDTH, BUTTON_HEIGHT);
    rect( RIGHTX, Y, BUTTON_WIDTH, BUTTON_HEIGHT);
    fill( 255, 0, 0 );
    textSize( 12 );
    text( "prev", LEFTX, Y);
    text( "next", RIGHTX, Y );
    
}

void mousePressed( )
{
     if ( mouseY >= Y - BUTTON_HEIGHT/2 && mouseY <= Y + BUTTON_HEIGHT/2 )
     {
        println( "y ok ");
         if( mouseX >= LEFTX - BUTTON_WIDTH/2  && mouseX <= LEFTX + BUTTON_WIDTH/2 )
         {
               if (index>0 )
               {
                  index--; 
               }
               
         }
         else if( mouseX >= RIGHTX - BUTTON_WIDTH/2  && mouseX <= RIGHTX + BUTTON_WIDTH/2 )
         {
               if (index< cols.length-1)
               {
                  index++; 
               }
               
         }         
     }
}

void showData( )
{
   rectMode( CORNER );
   fill(cols[index] );
   rect( width*.2, height*.2, width*.6, height*.6 );
   fill( 0 );
   textSize( 48 );
   text( index, width/2, height/2 );
   text( "index:", width/2, height*.3);
   fill( 255 );
   text( "click box", width/2, height*.9);
}

void initArray( )
{
   for( int i = 0; i < cols.length; i++)
   {
      float r = random( 256 );
      float g = random( 256 );
      float b = random( 256 );
      cols[i] = color( r, b, g );
   }
}
