// Animation control with specific keyPress
final int MAX= 5;


color [ ] cols;
int index;


void setup( )
{
  size( 300, 300 );
  textAlign( CENTER, CENTER );
  textSize( 48 );
  cols = new color[ MAX ];
  initArray( );

  index = 0;
}
void draw ( )
{
   background( 0 );
   showData( );
   
}

void keyPressed( )
{
   if( key == CODED )
   {
      if ( keyCode == LEFT )
      {
        index--;
      }
      else if ( keyCode == RIGHT )
      {
        index++;
      }
      if ( index < 0 )
      {
         index = cols.length-1; 
      }
      else if (index >= cols.length )
      {
          index = 0;
      }  
   }
}

void showData( )
{
   fill(cols[index] );
   rect( width*.2, height*.2, width*.6, height*.6 );
   fill( 0 );
   text( index, width/2, height/2 );
   text( "index:", width/2, height*.3);
   fill( 255 );
   text( "<-Press->", width/2, height*.9);
}

void initArray( )
{
   for( int i = 0; i < cols.length; i++)
   {
      float r = random( 256 );
      float g = random( 256 );
      float b = random( 256 );
      cols[i] = color( r, b, g );
   }
}
