// Animation control with mouse drag
//    i.e. button down when mouse moves
final int MAX= 5;


color [ ] cols;
int index;


void setup( )
{
  size( 300, 300 );
  textSize( 36 );
  textAlign( CENTER, CENTER );
  
  cols = new color[ MAX ];
  initArray( );

  index = 0;
}
void draw ( )
{
   background( 0 );
   showData( );   
}



void mouseDragged( )
{
   int x = mouseX;
   if ( x > width-2)
   {
      x = width-2;
   }
   if ( x < 0 )
   {
      x = 0; 
   }
   index =int( map( x, 0, width-1, 0, cols.length) );
}
void showData( )
{
   rectMode( CORNER );
   fill(cols[index] );
   rect( width*.2, height*.2, width*.6, height*.6 );
   fill( 0 );
   text( index, width/2, height/2 );
   text( "index:", width/2, height*.3);
   fill( 255 );
   text( "<Press & Drag>", width/2, height*.9);
}

void initArray( )
{
   for( int i = 0; i < cols.length; i++)
   {
      float r = random( 256 );
      float g = random( 256 );
      float b = random( 256 );
      cols[i] = color( r, b, g );
   }
}
